# Copyright © 2020 Profirator Oy, HYPERTEGRITY AG, omp computer gmbh
# This file is covered by the EUPL license.
# You may obtain a copy of the licence at
# https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12

#VARIABLES

#Resource requests. Memory 1 Mi = 1 Mebibyte. CPU 1000m = 1 CPU
#Apinf Platform
variables:
  #DEV
  DEV_MEMORY: "50Mi"
  DEV_CPU: "50m"
  #STAGING
  STAGING_MEMORY: "250Mi"
  STAGING_CPU: "250m"
  #PROD
  PROD_MEMORY: "250Mi"
  PROD_CPU: "250m"

#TEMPLATES

.deploy_template: &deploy_template
  tags:
    - kubernetes
  image: bitnami/kubectl:latest
  stage: deploy
  script:
    - echo "$KUBE" > "$(pwd)/kube.config"
    - sed -i "s/DOMAIN/${DOMAIN}/g" apinf-deployment.yaml
    - sed -i "s/NAMESPACE/${NAMESPACE}/g" apinf-deployment.yaml
    - sed -i "s/MEMORYREQUEST/${MEMORYREQUEST}/g" apinf-deployment.yaml
    - sed -i "s/CPUREQUEST/${CPUREQUEST}/g" apinf-deployment.yaml
    - kubectl apply -f apinf-deployment.yaml -n ${NAMESPACE} --kubeconfig "$(pwd)/kube.config"



image: bitnami/kubectl:latest

stages:
  - deploy
  
do deploy dev:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_DEV
    DOMAIN: $APINF_DEV_DOMAIN
    KUBE: $KUBECONFIG
    MEMORYREQUEST: $DEV_MEMORY
    CPUREQUEST: $DEV_CPU
  only:
    - master

do deploy staging:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_STAGING
    DOMAIN: $APINF_STAGING_DOMAIN
    KUBE: $KUBECONFIG
    MEMORYREQUEST: $STAGING_MEMORY
    CPUREQUEST: $STAGING_CPU
  only:
    - /^C./


do deploy prod:
  <<: *deploy_template
  variables:
    NAMESPACE: $NAMESPACE_PROD
    DOMAIN: $APINF_PROD_DOMAIN
    KUBE: $KUBECONFIG_PROD
    MEMORYREQUEST: $PROD_MEMORY
    CPUREQUEST: $PROD_CPU
  only:
    - /^R./
  when: manual
